/*
 * Copyright (c) 2019 REV Robotics
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of REV Robotics nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

package com.revrobotics.jni;

public class CANSparkMaxJNI extends RevJNIWrapper {

//CANSparkMaxLowLevel
  public static native long c_SparkMax_Create(int deviceId, int motortype);
  public static native void c_SparkMax_Destroy(long handle);
  public static native int c_SparkMax_GetFirmwareVersion(long handle);
  //public static native int c_SparkMax_GetSerialNumber(long handle, int* serialNumber[3]);
  public static native int c_SparkMax_GetDeviceId(long handle);
  public static native int c_SparkMax_SetMotorType(long handle, int type);
  public static native int c_SparkMax_GetMotorType(long handle);
  public static native int c_SparkMax_SetPeriodicFramePeriod(long handle, int frameId, int periodMs);

  public static native void c_SparkMax_SetControlFramePeriod(long handle, int periodMs);
  public static native int c_SparkMax_GetControlFramePeriod(long handle);
  
  public static native int c_SparkMax_SetEncoderPosition(long handle, float position);
  public static native int c_SparkMax_RestoreFactoryDefaults(long handle, boolean persist);

  public static native int c_SparkMax_SetFollow(long handle, int followerArbId, int followerCfg);
  public static native float c_SparkMax_SafeFloat(float f);
  public static native void c_SparkMax_EnableExternalControl(boolean enable);
  public static native void c_SparkMax_SetEnable(boolean enable);

  public static native int c_SparkMax_SetpointCommand(long handle, float value, int ctrlType,
                                    int pidSlot, float arbFeedforward, int arbFFUnits);

//CANSparkMax
  public static native int c_SparkMax_SetInverted(long handle, boolean inverted);
  public static native boolean c_SparkMax_GetInverted(long handle);
  public static native int c_SparkMax_SetSmartCurrentLimit(long handle, int stallLimit, int freeLimit, int limitRPM);
  public static native int c_SparkMax_GetSmartCurrentStallLimit(long handle);
  public static native int c_SparkMax_GetSmartCurrentFreeLimit(long handle);
  public static native int c_SparkMax_GetSmartCurrentLimitRPM(long handle);
  public static native int c_SparkMax_SetSecondaryCurrentLimit(long handle, float limit, int chopCycles);
  public static native float c_SparkMax_GetSecondaryCurrentLimit(long handle);
  public static native int c_SparkMax_GetSecondaryCurrentLimitCycles(long handle);
  public static native int c_SparkMax_SetIdleMode(long handle, int idlemode);
  public static native int c_SparkMax_GetIdleMode(long handle);
  public static native int c_SparkMax_EnableVoltageCompensation(long handle, float nominalVoltage);
  public static native float c_SparkMax_GetVoltageCompensationNominalVoltage(long handle);
  public static native int c_SparkMax_DisableVoltageCompensation(long handle);
  public static native int c_SparkMax_SetOpenLoopRampRate(long handle, float rate);
  public static native float c_SparkMax_GetOpenLoopRampRate(long handle);
  public static native int c_SparkMax_SetClosedLoopRampRate(long handle, float rate);
  public static native float c_SparkMax_GetClosedLoopRampRate(long handle);
  public static native boolean c_SparkMax_IsFollower(long handle);
  public static native int c_SparkMax_GetFaults(long handle);
  public static native int c_SparkMax_GetStickyFaults(long handle);
  public static native boolean c_SparkMax_GetFault(long handle, int faultId);
  public static native boolean c_SparkMax_GetStickyFault(long handle, int faultId);
  public static native float c_SparkMax_GetBusVoltage(long handle);
  public static native float c_SparkMax_GetAppliedOutput(long handle);
  public static native float c_SparkMax_GetOutputCurrent(long handle);
  public static native float c_SparkMax_GetMotorTemperature(long handle);
  public static native int c_SparkMax_ClearFaults(long handle);
  public static native int c_SparkMax_BurnFlash(long handle);
  public static native int c_SparkMax_SetCANTimeout(long handle, int timeoutMs);
  public static native int c_SparkMax_EnableSoftLimit(long handle, int dir, boolean enable);
  public static native boolean c_SparkMax_IsSoftLimitEnabled(long handle, int dir);
  public static native int c_SparkMax_SetSoftLimit(long handle, int dir, float limit);
  public static native float c_SparkMax_GetSoftLimit(long handle, int dir);
  public static native int c_SparkMax_SetSensorType(long handle, int sensorType);

//Digital Input
  public static native int c_SparkMax_SetLimitPolarity(long handle, int sw, int polarity);
  public static native int c_SparkMax_GetLimitPolarity(long handle, int sw);
  public static native boolean c_SparkMax_GetLimitSwitch(long handle, int sw);
  public static native int c_SparkMax_EnableLimitSwitch(long handle, int sw, boolean enable);
  public static native boolean c_SparkMax_IsLimitEnabled(long handle, int sw);

//CANAnalog
  public static native float c_SparkMax_GetAnalogPosition(long handle);
  public static native float c_SparkMax_GetAnalogVelocity(long handle);
  public static native float c_SparkMax_GetAnalogVoltage(long handle);
  public static native int c_SparkMax_SetAnalogPositionConversionFactor(long handle, float conversion);
  public static native int c_SparkMax_SetAnalogVelocityConversionFactor(long handle, float conversion);
  public static native float c_SparkMax_GetAnalogPositionConversionFactor(long handle);
  public static native float c_SparkMax_GetAnalogVelocityConversionFactor(long handle);
  public static native int c_SparkMax_SetAnalogInverted(long handle, boolean inverted);
  public static native boolean c_SparkMax_GetAnalogInverted(long handle);
  public static native int c_SparkMax_SetAnalogAverageDepth(long handle, int depth);
  public static native int c_SparkMax_GetAnalogAverageDepth(long handle);
  public static native int c_SparkMax_SetAnalogMeasurementPeriod(long handle, int samples);
  public static native int c_SparkMax_GetAnalogMeasurementPeriod(long handle);
  public static native int c_SparkMax_SetAnalogMode(long handle, int mode);
  public static native int c_SparkMax_GetAnalogMode(long handle);

//CANEncoder
  public static native float c_SparkMax_GetEncoderPosition(long handle);
  public static native float c_SparkMax_GetEncoderVelocity(long handle);
  public static native int c_SparkMax_SetPositionConversionFactor(long handle, float conversion);
  public static native int c_SparkMax_SetVelocityConversionFactor(long handle, float conversion);
  public static native float c_SparkMax_GetPositionConversionFactor(long handle);
  public static native float c_SparkMax_GetVelocityConversionFactor(long handle);
  public static native int c_SparkMax_SetAverageDepth(long handle, int depth);
  public static native int c_SparkMax_GetAverageDepth(long handle);
  public static native int c_SparkMax_SetMeasurementPeriod(long handle, int samples);
  public static native int c_SparkMax_GetMeasurementPeriod(long handle);
  public static native int c_SparkMax_SetCPR(long handle, int cpr);
  public static native int c_SparkMax_GetCPR(long handle);
  public static native int c_SparkMax_SetEncoderInverted(long handle, boolean inverted);
  public static native boolean c_SparkMax_GetEncoderInverted(long handle);

//CANPIDController
  public static native int c_SparkMax_SetP(long handle, int slotID, float gain);
  public static native int c_SparkMax_SetI(long handle, int slotID, float gain);
  public static native int c_SparkMax_SetD(long handle, int slotID, float gain);
  public static native int c_SparkMax_SetDFilter(long handle, int slotID, float gain);
  public static native int c_SparkMax_SetFF(long handle, int slotID, float gain);
  public static native int c_SparkMax_SetIZone(long handle, int slotID, float IZone);
  public static native int c_SparkMax_SetOutputRange(long handle, int slotID, float min, float max);
  public static native float c_SparkMax_GetP(long handle, int slotID);
  public static native float c_SparkMax_GetI(long handle, int slotID);
  public static native float c_SparkMax_GetD(long handle, int slotID);
  public static native float c_SparkMax_GetDFilter(long handle, int slotID);
  public static native float c_SparkMax_GetFF(long handle, int slotID);
  public static native float c_SparkMax_GetIZone(long handle, int slotID);
  public static native float c_SparkMax_GetOutputMin(long handle, int slotID);
  public static native float c_SparkMax_GetOutputMax(long handle, int slotID);

  public static native int c_SparkMax_SetSmartMotionMaxVelocity(long handle, int slotID, float maxVel);
  public static native int c_SparkMax_SetSmartMotionMaxAccel(long handle, int slotID, float maxAccel);
  public static native int c_SparkMax_SetSmartMotionMinOutputVelocity(long handle, int slotID, float minVel);
  public static native int c_SparkMax_SetSmartMotionAccelStrategy(long handle, int slotID, int accelStrategy);
  public static native int c_SparkMax_SetSmartMotionAllowedClosedLoopError(long handle, int slotID, float allowedError);
  public static native float c_SparkMax_GetSmartMotionMaxVelocity(long handle, int slotID);
  public static native float c_SparkMax_GetSmartMotionMaxAccel(long handle, int slotID);
  public static native float c_SparkMax_GetSmartMotionMinOutputVelocity(long handle, int slotID);
  public static native int c_SparkMax_GetSmartMotionAccelStrategy(long handle, int slotID);
  public static native float c_SparkMax_GetSmartMotionAllowedClosedLoopError(long handle, int slotID);

  public static native int c_SparkMax_SetIMaxAccum(long handle, int slotID, float iMaxAccum);
  public static native float c_SparkMax_GetIMaxAccum(long handle, int slotID);
  public static native int c_SparkMax_SetIAccum(long handle, float iAccum);
  public static native float c_SparkMax_GetIAccum(long handle);

  public static native int c_SparkMax_SetFeedbackDevice(long handle, int sensorID);
  public static native int c_SparkMax_SetFeedbackDeviceRange(long handle, float min, float max);
  public static native int c_SparkMax_GetFeedbackDeviceID(long handle);

  public static native int c_SparkMax_GetAPIMajorRevision();
  public static native int c_SparkMax_GetAPIMinorRevision();
  public static native int c_SparkMax_GetAPIBuildRevision();
  public static native int c_SparkMax_GetAPIVersion();

  public static native int c_SparkMax_GetLastError(long handle);
}
